'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('../underscore_ext'),
    times = _require.times,
    maxnull = _require.maxnull,
    minnull = _require.minnull;

var CanvasDrawing = require('../CanvasDrawing');
var React = require('react');

function drawScatterPlot(vg, opts) {
	var data = opts.data,
	    width = opts.width,
	    height = opts.zoom.height,
	    _data = (0, _slicedToArray3.default)(data, 2),
	    x = _data[0],
	    y = _data[1];

	vg.box(0, 0, width, height, "white");

	var ctx = vg.context(),

	//		img = ctx.createImageData(width, height),
	img = ctx.getImageData(0, 0, width, height),
	    xmax = maxnull(x),
	    xmin = minnull(x),
	    ymax = maxnull(y),
	    ymin = minnull(y),
	    scalex = function scalex(x) {
		return Math.round((x - xmin) * width / (xmax - xmin));
	},
	    scaley = function scaley(y) {
		return Math.round((y - ymin) * height / (ymax - ymin));
	};

	var white = [255, 255, 255, 255],
	    black = [0, 0, 0, 255],
	    mark = [[white, black, white], [black, black, black], [white, black, white]];

	x.forEach(function (xi, i) {
		var yi = y[i],
		    xc = scalex(xi),
		    yc = scaley(yi),
		    istart = xc <= 0 ? 1 : 0,
		    iend = xc >= width - 1 ? 2 : 3,
		    jstart = yc <= 0 ? 1 : 0,
		    jend = yc >= height - 1 ? 2 : 3;

		console.log('start mark');
		for (var _i = istart; _i < iend; ++_i) {
			var pxRow = (yc - 1 + _i) * width,
			    buffStart = pxRow * 4;
			for (var j = jstart; j < jend; j++) {
				//				console.log(xi, xc, istart, iend, jstart, jend);
				console.log(buffStart + 4 * (xc + j) + 0);
				img.data[buffStart + 4 * (xc + j) + 0] = mark[_i][j][0];
				img.data[buffStart + 4 * (xc + j) + 1] = mark[_i][j][1];
				img.data[buffStart + 4 * (xc + j) + 2] = mark[_i][j][2];
				img.data[buffStart + 4 * (xc + j) + 3] = mark[_i][j][3];
				console.log(mark[_i][j][0], mark[_i][j][1], mark[_i][j][2], mark[_i][j][3]);
			}
		}
		console.log('end mark');
	});

	ctx.putImageData(img, 0, 0);
}

var rndx = times(100, function () {
	return 10 + 10 * Math.random();
}),
    rndy = times(100, function () {
	return 10 + 10 * Math.random();
});

var data = [[].concat((0, _toConsumableArray3.default)(rndx), (0, _toConsumableArray3.default)(rndx.map(function (x) {
	return -x;
}))), [].concat((0, _toConsumableArray3.default)(rndy), (0, _toConsumableArray3.default)(rndy.map(function (x) {
	return -x;
})))];
var ScatterPlot = React.createClass({
	displayName: 'ScatterPlot',
	render: function render() {
		return React.createElement(CanvasDrawing, {
			draw: drawScatterPlot,
			width: 400,
			zoom: { height: 200 },
			data: data });
	}
});

module.exports = ScatterPlot;