'use strict';
var {pick, flatten} = require('underscore');

var sha = require('js-sha1');

var fs = require('fs');
var path = require('path');

var dst = './cypress/fixtures';

var src = './cypress/xhr-cache';
var files = [
	'Datapages.json',
	'heatmap.json',
	'Transcript-page.json',
	'Viz-page.json'];

function readFile(file) {
	return JSON.parse(fs.readFileSync(path.join(src, file), 'utf8'));
}

var allQueries = flatten(files.map(readFile));

function saveQuery(query) {
	var req = JSON.stringify(pick(query, 'url', 'method', 'body')),
		id = sha(req),
		resp = JSON.stringify(pick(query, 'status', 'response'));

	fs.writeFileSync(path.join(dst, `${id}.json`), resp, 'utf8');
}

allQueries.forEach(saveQuery);
